package SpaceTime.DataModel;


/**
* SpaceTime/DataModel/SpaceTimePropertyOperations.java .
* Generated by the IDL-to-Java compiler (portable), version "3.2"
* from SpaceTime/DataModel/SpaceTimeProperty.idl
* Monday, July 7, 2008 2:16:35 PM EDT
*/


/**
	Property class for SpaceTime nodes and edges. A property can contain
	either an integer, double, string value or a piecewise linear function.
	*/
public interface SpaceTimePropertyOperations 
{
  SpaceTime.DataModel.PropertyValue GetOriginalValue () throws Ch.Elca.Iiop.GenericUserException;
  void InitializeOriginalValue () throws Ch.Elca.Iiop.GenericUserException;
  void FlushOriginalValue () throws Ch.Elca.Iiop.GenericUserException;
  SpaceTime.DataModel.PropertyValue GetValue () throws Ch.Elca.Iiop.GenericUserException;

  /// Gets the function data associated with this property.
  SpaceTime.DataModel.CertainPlf GetCertainPlf () throws Ch.Elca.Iiop.GenericUserException;
  SpaceTime.DataModel.YUncertainPlf GetYUncertainPlf () throws Ch.Elca.Iiop.GenericUserException;
  SpaceTime.DataModel.UncertainPlf GetUncertainPlf () throws Ch.Elca.Iiop.GenericUserException;

  /// Associates function data with this node.
  void SetCertainPlf (SpaceTime.DataModel.CertainPlf certainPlf, int dataType) throws Ch.Elca.Iiop.GenericUserException;
  void SetYUncertainPlf (SpaceTime.DataModel.YUncertainPlf yUncertainPlf) throws Ch.Elca.Iiop.GenericUserException;
  void SetUncertainPlf (SpaceTime.DataModel.UncertainPlf uncertainPlf) throws Ch.Elca.Iiop.GenericUserException;

  /// Get the uncertainty data associated with this node if it exists.
  SpaceTime.DataModel.UncertaintyDistributionData GetUncertaintyData () throws Ch.Elca.Iiop.GenericUserException;

  /// Associates uncertainty data with this node.
  void SetUncertaintyData (SpaceTime.DataModel.UncertaintyDistributionData uncertaintyData) throws Ch.Elca.Iiop.GenericUserException;

  /// Assigns integer value
  void SetIntValue (int value) throws Ch.Elca.Iiop.GenericUserException;

  /// Assigns money value, money value is represented by an integer
  void SetMoneyValue (int value) throws Ch.Elca.Iiop.GenericUserException;

  /// Assigns string value
  void SetStringValue (String value) throws Ch.Elca.Iiop.GenericUserException;

  /// Returns true if this property contains a numeric value.
  boolean ContainsValue () throws Ch.Elca.Iiop.GenericUserException;

  /// Owner node of this property
  SpaceTime.DataModel.SpaceTimeNode OwnerNode ();

  /// Owner node of this property
  void OwnerNode (SpaceTime.DataModel.SpaceTimeNode newOwnerNode);

  /// Label
  String Label ();

  /// Category (optional)
  String Category ();

  /// Service category (optional)
  String ServiceCategory ();

  /// Priority
  int Priority ();

  /// Priority
  void Priority (int newPriority);

  /// IsDefault flag
  boolean IsDefault ();

  /// IsDefault flag
  void IsDefault (boolean newIsDefault);

  /// IsHidden flag (optional)
  boolean IsHidden ();

  /// IsEditable flag (optional)
  boolean IsEditable ();

  /// Data type
  int DataType ();

  /// @ADD
  int StoredDataType ();

  /// Get int value
  int IntValue ();
  int MoneyValue ();

  /// Get string value
  String StringValue ();

  /// Property type
  String PropertyType ();

  /// Property type
  void PropertyType (String newPropertyType);

  /// @ADD Allowed values enumaration for string properties, if null then no restrictions
  String[] GetAllowedValues () throws Ch.Elca.Iiop.GenericUserException;
} // interface SpaceTimePropertyOperations
